<?xml version="1.0" encoding="utf-8"?>
<!--
     XLIFF Version 2.1
     Committee Specification Draft 02 / Public Review Draft 02
     07 February 2017
     Copyright (c) OASIS Open 2017. All Rights Reserved.
     Source: http://docs.oasis-open.org/xliff/xliff-core/v2.1/csprd02/schemas/
     Latest version of narrative specification: http://docs.oasis-open.org/xliff/xliff-core/v2.1/xliff-core-v2.1.html
     TC IPR Statement: https://www.oasis-open.org/committees/xliff/ipr.php
     
-->
<!DOCTYPE schematron [
<!-- Entities for XLIFF V2.x publishing.................................... -->
<!--copy all of these to all *.sch files and also to the Oxygen framework for validating Docbook 4.5 if you use Oxygen -->
<!ENTITY name "xliff-core-v2.1">
<!ENTITY pversion "2.0">
<!ENTITY version "2.1">
<!ENTITY bschversion "2.0">
<!ENTITY cschversion "2.1">

<!ENTITY stage "csprd02">
<!ENTITY pstage "csprd01">
<!ENTITY standard "Commitee Specification Draft 02 / Public Review Draft 02">

<!ENTITY this-loc "http://docs.oasis-open.org/xliff/xliff-core/v&version;/&stage;">
<!ENTITY previous-loc "http://docs.oasis-open.org/xliff/xliff-core/v&version;/&pstage;">
<!ENTITY latest-loc "http://docs.oasis-open.org/xliff/xliff-core/v&version;">
<!ENTITY pubdate "07 February &pubyear;">
<!ENTITY pubyear "2017">
<!ENTITY releaseinfo "Standards Track Work Product">
<!-- End of XLIFF V2.x publishing entities -->
]>


<sch:schema   
    xmlns:sch="http://purl.oclc.org/dsdl/schematron"
    xmlns:xlf="urn:oasis:names:tc:xliff:document:2.0"
    xmlns:mtc="urn:oasis:names:tc:xliff:matches:2.0"
    xmlns:ctr="urn:oasis:names:tc:xliff:changetracking:2.1"
	xmlns:res="urn:oasis:names:tc:xliff:resourcedata:2.0"
	xmlns:its="http://www.w3.org/2005/11/its"
	xmlns:itsm="urn:oasis:names:tc:xliff:itsm:2.1"
    queryBinding='xslt2' 
    schemaVersion='ISO19757-3'>
    <sch:title>Schematron rules for checking the constraints of the ITS module against XLIFF Version &version;</sch:title>
    <sch:ns prefix="its" uri="http://www.w3.org/2005/11/its"/>
    <sch:ns prefix="xlf" uri="urn:oasis:names:tc:xliff:document:2.0"/>
    <sch:ns prefix="ctr" uri="urn:oasis:names:tc:xliff:changetracking:2.1"/>
    <sch:ns prefix="itsm" uri="urn:oasis:names:tc:xliff:itsm:2.1"/>
    
    <!-- ITS rules for mapping ITS data categories used in XLIFF 2.x. The rules are to be consumed by an ITS 2.0 conformant processor. The rules are ordered following the data category sub sections of the ITS module section in the XLIFF 2.1 specification.-->
    
    <its:rules version="2.0" queryLanguage="xpath">
        
        <!-- Rules for Allowed Characters -->
        <its:allowedCharactersRule selector="//xlf:mrk[@type='its:generic' and (@its:allowedCharacters)]" allowedCharactersPointer="@its:allowedCharacters"/>
        
        <!-- Rules for Domain -->
        <its:domainRule selector="//xlf:mrk[@type='its:generic' and (@its:domains)]" domainPointer="@its:domains"/>
        
        <!-- Rules for Localization Quality Issue. Note that the pointer attribute is only available for the local locQualityIssuesRef attribute, hence the mapping is also only for that attribute and no other Localization Quality Issue attributes. But this limitation is OK since a processor can work with this data category locally.-->
        <its:locQualityIssueRule selector="//xlf:mrk[@type='its:generic' and (@its:locQualityIssueType)]" locQualityIssuesRefPointer="@its:locQualityIssuesRefPointer"/>
        
        <!-- Rules for Localization Quality Rating: cannot be written since there are no pointer attributes for this data category. But this limitation is OK since a processor can work with this data category locally. -->
        
        <!-- Rules for Text Analysis -->
        <its:textAnalysisRule selector="//xlf:mrk[@type='its:generic' and (@its:taClassRef or @its:taIdentRef)]" taClassRefPointer="@its:taClassRef" taIdentRefPointer="@its:taIdentRef"/>
        
        <!-- Rules for Localization Note -->
        <its:locNoteRule selector="//xlf:note" localizationNotePointer="self::*" locNoteType="description"/>
        
        <!-- Rules for Preserve Space: cannot be written since there are not pointer attributes for Preserve Space. But this limitation is OK since a processor can work with this data category locally.-->
        
        <!-- Rules for Translate -->
        <its:translateRule selector="//xlf:*[@translate='no']" translate='no'/>
        <its:translateRule selector="//xlf:*[@translate='yes']" translate='yes'/>
        
        <!-- Rules for External Resource -->
        <its:externalResourceRefRule selector="//res:source | //res:target" externalResourceRefPointer="@href"/>
        
        <!-- Rules for Language Information -->
        <its:langRule selector="//xlf:*[@xml:lang]" langPointer="@xml:lang"/>
        <its:langRule selector="//xlf:*[@itsm:lang]" langPointer="@itsm:lang"/>
        
        <!-- Rules for MT Confidence: cannot be written since there is not pointer attribute for MT Confidence. But this limitation is OK since a processor can work with this data category locally. -->
        
        <!-- Rules for Provenance: cannot be written since there are no pointer attributes for the provenance records written in  XLIFF. But this limitation is OK since a processor can work with this data category locally. -->
        
        <!-- Rules for Terminology -->
        <its:termRule selector="//xlf:mrk[@type='term' and @ref]" termInfoRefPointer="@ref"/>
        
        <!-- Rules for Directionality: This data category is not mapped to XLIFF 2.X -->
        
        <!-- Rules for Elements Within Text: This data category is not represented as metadata in XLIFF 2.X -->
        
        <!-- Rules for ID Value: This data category is not represented as metadata in XLIFF 2.X -->
        
        <!-- Rules for Locale Filter: cannot be written since there are no pointer attributes for locale filter written in  XLIFF. But this limitation is OK since a processor can work with this data category locally. -->
        
        <!-- Rules for Target Pointer -->
        <its:targetPointerRule selector="//xlf:source" targetPointer="../xlf:target"/>
        
        <!-- Rules for storage size: The data category is not covered by the XLIFF 2.1 specification, so no rule is provided. -->
        
    </its:rules>
    <!-- End of ITS Rules -->
    
    <sch:pattern>
        <sch:rule context="ctr:revision">
            <sch:report test="@its:*[not(name()='its:toolRef')][not(name()='its:tool')][not(name()='its:revToolRef')][not(name()='its:revTool')]
                [not(name()='its:revPersonRef')][not(name()='its:revPerson')][not(name()='its:revOrgRef')][not(name()='its:revOrg')]
                [not(name()='its:org')][not(name()='its:provenanceRecordsRef')][not(name()='its:personRef')][not(name()='its:person')]
                [not(name()='its:orgRef')][not(name()='its:annotatorsRef')]">
                Invalid 'itsm' attribute used in 'revision'.
            </sch:report>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="xlf:mrk[@its:annotatorsRef] | xlf:sm[@its:annotatorsRef]">
            <sch:assert test="not(@type) or @type='its:generic'">
                When the 'its:annotatorsRef' attribute is used, the optional 'type' attribute must be set to 'its:generic' if declared.
            </sch:assert>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="xlf:mrk[@its:locQualityIssuesRef] | xlf:sm[@its:locQualityIssuesRef]">
            <sch:assert test="not(@type) or @type='its:generic'">
                When used in ITS Localization Quality Issue Annotation, the optional 'type' attribute must be set to 'its:generic' if declared.
            </sch:assert>
            <sch:report test="@its:locQualityIssueType or @its:locQualityIssueComment">
                When the 'its:locQualityIssuesRef' attribute is used, the following attributes must be declared: 'its:locQualityIssueType' and 'its:locQualityIssueComment'.
            </sch:report>
            <sch:report test="@its:locQualityIssueSeverity or @its:locQualityIssueProfileRef or @its:locQualityIssueEnabled">
                When the 'its:locQualityIssuesRef' attribute is used, the following attributes must be declared: 'its:locQualityIssueSeverity', 'its:locQualityIssueProfileRef' and 'its:locQualityIssueEnabled'..
            </sch:report>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="xlf:mrk[@its:locQualityIssueSeverity] | xlf:mrk[@its:locQualityIssueProfileRef] | 
            xlf:sm[@its:locQualityIssueSeverity] | xlf:sm[@its:locQualityIssueProfileRef]">
            <sch:report test="@its:locQualityIssuesRef">
                When the 'its:locQualityIssueSeverity' or 'its:locQualityIssueProfileRef' attributes are used, the 'its:locQualityIssuesRef' must not be declared.
            </sch:report>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="xlf:mrk[@its:locQualityRatingScore] | xlf:sm[@its:locQualityRatingScore]">
            <sch:report test="@its:locQualityRatingVote">
                When the 'its:locQualityRatingScore' attribute is used, the 'itms:locQualityRatingVote' attribute is not allowed.
            </sch:report>
            <sch:assert test="not(@type) or @type='its:generic'">
                When the 'its:locQualityRatingScore' attribute is used, the optional 'type' attribute must be set to 'its:generic' if declared.
            </sch:assert>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="xlf:mrk[@its:locQualityRatingVote] | xlf:sm[@its:locQualityRatingVote]">
            <sch:report test="@its:locQualityRatingScore">
                When the 'its:locQualityRatingVote' attribute is used, the 'itms:locQualityRatingScore' attribute is not allowed.
            </sch:report>
            <sch:assert test="not(@type) or @type='its:generic'">
                When the 'its:locQualityRatingVote' attribute is used, the optional 'type' attribute must be set to 'its:generic' if declared.
            </sch:assert>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="xlf:*[@its:locQualityRatingScoreThreshold]">
            <sch:assert test="@its:locQualityRatingScore or ancestor::xlf:*[@its:locQualityRatingScore]">
                The 'its:locQualityRatingScoreThreshold' attribute may be set only if 'its:locQualityRatingScore' is declared or inherited from upper levels.
            </sch:assert>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="xlf:*[@its:locQualityRatingVoteThreshold]">
            <sch:assert test="@its:locQualityRatingVote or ancestor::xlf:*[@its:locQualityRatingVote]">
                The 'its:locQualityRatingVoteThreshold' attribute may be set only if 'its:locQualityRatingVote' is declared or inherited from upper levels.
            </sch:assert>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="xlf:mrk[@its:taIdentRef] | xlf:sm[@its:taIdentRef]">
            <sch:report test="@its:taSource or @its:taIdent">
                When the 'its:taIdentRef' attribute is used, the following attributes are not allowed: 'its:taSource' and 'its:taIdent'.
            </sch:report>
            <sch:assert test="not(@type) or @type='its:generic'">
                When the 'its:taIdentRef' attribute is used, the optional 'type' attribute must be set to 'its:generic' if declared.
            </sch:assert>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="xlf:mrk[@its:taSource] | xlf:sm[@its:taSource] |
            xlf:mrk[@its:taIdent] | xlf:sm[@its:taIdent]">
            <sch:report test="@its:taIdentRef">
                When the 'its:taSource' or 'its:taIdent' attributes are used, the 'its:taIdentRef' attribute is not allowed.
            </sch:report>
            <sch:assert test="@its:taSource and @its:taIdent">
                The pair of 'its:taSource' and 'its:taIdent'attributes must be present at the same time.
            </sch:assert>
            <sch:assert test="not(@type) or @type='its:generic'">
                When the 'its:taSource' and 'its:taIdent' attributes are used, the optional 'type' attribute must be set to 'its:generic' if declared.
            </sch:assert>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="xlf:mrk[@its:taClassRef] | xlf:sm[@its:taClassRef]">
            <sch:assert test="not(@type) or @type='its:generic'">
                When the 'its:taClassRef' attribute is used, the optional 'type' attribute must be set to 'its:generic' if declared.
            </sch:assert>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="xlf:mrk[@its:lang] | xlf:sm[@its:lang]">
            <sch:assert test="not(@type) or @type='its:generic'">
                When the 'its:lang' attribute is used, the optional 'type' attribute must be set to 'its:generic' if declared.
            </sch:assert>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="xlf:mrk[@its:mtConfidence] | xlf:sm[@its:mtConfidence]">
            <sch:assert test="not(@type) or @type='its:generic'">
                When the 'its:mtConfidence' attribute is used, the optional 'type' attribute must be set to 'its:generic' if declared.
            </sch:assert>
        </sch:rule>
    </sch:pattern>
    
    <sch:pattern>
        <sch:rule context="xlf:mrk[@its:provenanceRecordsRef] | xlf:sm[@its:provenanceRecordsRef]">
            <sch:assert test="not(@type) or @type='its:generic'">
                When the 'its:provenanceRecordsRef' attribute is used, the optional 'type' attribute must be set to 'its:generic' if declared.
            </sch:assert>
            <sch:report test="@its:org or @its:orgRef or @its:person or 
                @its:personRef or @its:revOrg or @its:revOrgRef or 
                @its:revPerson or @its:revPersonRef or @its:revTool or
                @its:revToolRef or @its:tool or @its:toolRef">
                When the 'its:provenanceRecordsRef' attribute is used, the following attributes are not allowed: its:org, its:orgRef, its:person, its:personRef, its:revOrg,
                its:revOrgRef, its:revPerson, its:revPersonRef, its:revTool, its:revToolRef, its:tool and its:toolRef.
                
            </sch:report>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="xlf:mrk[@its:allowedCharacters] | xlf:mrk[@itsm:domains] | xlf:mrk[@itsm:lang] | xlf:mrk[@its:localeFilterList] |
            xlf:sm[@its:allowedCharacters] | xlf:sm[@itsm:domains] | xlf:sm[@itsm:lang] | xlf:sm[@its:localeFilterList]">
            <sch:assert test="not(@type) or @type='its:generic'">
                When the 'its:allowedCharacters', 'its:domains' or 'its:localeFilterList attributes are used, the value of optional 'type' attribute must be set to 'its:generic'.
            </sch:assert>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="xlf:mrk[@its:locQualityIssuesRef] | xlf:sm[@its:locQualityIssuesRef]">
            <sch:report test="@its:locQualityIssueSeverity or @its:locQualityIssueProfileRef or @its:locQualityIssueEnabled">
                If the 'its:locQualityIssuesRef' attribute is declared, the following attributes are not allowd: its:locQualityIssueSeverity, its:locQualityIssueProfileRef, and its:locQualityIssueEnabled".
            </sch:report>
            <sch:assert test="count(ancestor::xlf:unit//its:locQualityIssues[@id=current()/@its:locQualityIssuesRef])=1">
                The value of the locQualityIssuesRef attribute must be an NMTOKEN value of one of the id attributes declared on a &lt;locQualityIssues> elements within the same 'unit'.
            </sch:assert>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="xlf:mrk[@its:locQualityIssuesRef] | xlf:sm[@its:locQualityIssuesRef]">
            <sch:report test="@its:locQualityIssueType or @its:locQualityIssueComment">
                When 'its:locQualityIssuesRef' is declared, 'its:locQualityIssueType' and its:locQualityIssueComment are not allowed.
            </sch:report>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="xlf:mrk[@its:locQualityIssueType] | xlf:mrk[@its:locQualityIssueComment] |
                           xlf:sm[@its:locQualityIssueType] | xlf:sm[@its:locQualityIssueComment] ">
            <sch:report test="@its:locQualityIssuesRef">
                When 'its:locQualityIssueType' or 'its:locQualityIssueComment' are declared, 'its:locQualityIssuesRef' is not allowed.
            </sch:report>
        </sch:rule>
    </sch:pattern>
   <sch:pattern>
        <sch:rule context="xlf:*[@its:annotatorsRef][not(contains(@its:annotatorsRef, ' '))]">
            <sch:let name="ref" value="@its:annotatorsRef"/>
            <sch:let name="its-dc-id" value="substring-before($ref,'|')"/>
            <sch:report test="$its-dc-id!='allowed-characters' and $its-dc-id!='directionality' and $its-dc-id!='domain' and $its-dc-id!='elements-within-text' and
                $its-dc-id!='external-resource' and $its-dc-id!='id-value' and $its-dc-id!='language-information' and
                $its-dc-id!='locale-filter' and $its-dc-id!='localization-note' and $its-dc-id!='localization-quality-issue' and
                $its-dc-id!='localization-quality-rating' and $its-dc-id!='mt-confidence' and $its-dc-id!='preserve-space' and
                $its-dc-id!='provenance' and $its-dc-id!='storage-size' and $its-dc-id!='target-pointer' and
                $its-dc-id!='terminology' and $its-dc-id!='text-analysis' and $its-dc-id!='translate'">
                Invalid id used for the ITS datacategory <sch:value-of select="$its-dc-id"/>. Please see the Specification for guidelines on the value of this attribute.
            </sch:report>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="xlf:*[@its:annotatorsRef][(contains(@its:annotatorsRef, ' '))]">
            <sch:let name="ids-string" value=" replace(@its:annotatorsRef, '\|\w+','')"/>
            <sch:let name="ids-tokens" value="tokenize($ids-string, ' ')"/>
            <sch:report test="count($ids-tokens)!=count(distinct-values($ids-tokens))">
                Each ITS data category identifier must not be used more than once.
            </sch:report>
            <sch:assert test="matches($ids-string, '^(allowed-characters)?\s*(directionality)?\s*(domain)?\s*(elements-within-text)?\s*(external-resource)?\s*(id-value)?\s*(language-information)?\s*(locale-filter)?\s*(localization-note)?\s*(localization-quality-issue)?\s*(localization-quality-rating)?\s*(mt-confidence)?\s*(preserve-space)?\s*(provenance)?\s*(storage-size)?\s*(target-pointer)?\s*(terminology)?\s*(text-analysis)?\s*(translate)?$')">
                The space separated triples are not ordered alphabetically as per the ITS Data category identifier or contain iligal value. Please see the Specification for guidelines on the value of this attribute.
            </sch:assert>
         </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="its:locQualityIssue">
            <sch:assert test="@locQualityIssueType or @locQualityIssueComment">
                At least one of the attributes locQualityIssueType or locQualityIssueComment must be set.
            </sch:assert>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="its:provenanceRecord">
            <sch:assert test="@its:org or @its:orgRef or @its:person or 
                @its:personRef or @its:revOrg or @its:revOrgRef or 
                @its:revPerson or @its:revPersonRef or @its:revTool or
                @its:revToolRef or @its:tool or @its:toolRef">
                At least one of the followings must be set: its:org, its:orgRef, its:person, its:personRef, its:revOrg,
                its:revOrgRef, its:revPerson, its:revPersonRef, its:revTool, its:revToolRef, its:tool and its:toolRef.
            </sch:assert>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="its:locQualityIssues | its:provenanceRecords[ancestor::xlf:unit]">
            <sch:let name="id" value="@id"/>
            <sch:let name="counter" value="count(ancestor::xlf:unit//its:locQualityIssues[@id=$id] | ancestor::xlf:unit//its:provenanceRecords[@id=$id])"/>
            <sch:assert test="$counter=1">
                Value of 'id' must be unique among all of  &lt;locQualityIssues> and &lt;provenanceRecords> elements within the enclosing 'unit'.
            </sch:assert>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="its:provenanceRecords[ancestor::xlf:group][not(ancestor::xlf:unit)]">
            <sch:let name="id" value="@id"/>
            <sch:let name="counter" value="count(ancestor::xlf:group[1]//its:provenanceRecords[@id=$id][not(ancestor::xlf:unit)])"/>
            <sch:assert test="$counter=1">
                Value of 'id' must be unique among all of  &lt;provenanceRecords> elements within the enclosing 'group'.
            </sch:assert>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="its:provenanceRecords[ancestor::xlf:file][not(ancestor::xlf:unit)][not(ancestor::xlf:group)]">
            <sch:let name="id" value="@id"/>
            <sch:let name="counter" value="count(ancestor::xlf:file//its:provenanceRecords[@id=$id][not(ancestor::xlf:group)][not(ancestor::xlf:unit)])"/>
            <sch:assert test="$counter=1">
                Value of 'id' must be unique among all of  &lt;provenanceRecords> elements within the enclosing 'file'.
            </sch:assert>
        </sch:rule>
    </sch:pattern>
    <sch:pattern>
        <sch:rule context="xlf:*[@its:locQualityIssuesRef]">
            <sch:assert test="not(@its:locQualityIssueSeverity)">
                If 'its:locQualityIssuesRef' attribute is declared, the 'its:locQualityIssueSeverity' must not be used. 
            </sch:assert>
            <sch:assert test="not (@its:locQualityIssueProfileRef) ">
                If 'its:locQualityIssuesRef' attribute is declared, the 'its:locQualityIssueProfileRef' must not be used. 
            </sch:assert>
            <sch:assert test="not(@its:locQualityIssueEnabled)">
                If 'its:locQualityIssuesRef' attribute is declared, the 'its:locQualityIssueEnabled' must not be used. 
            </sch:assert>
        </sch:rule>        
    </sch:pattern>
</sch:schema>
